;=====================================================
;	TabFunctions SE for Doors CS 6.0 and higher
;	Written by Kerm Martian
;	This code and attached program released under the GPL
;	Anyone is free to modify and rerelease this program
;======================================================

.nolist				;defines, includes, and equates
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#IFDEF TI83
#include "doorscs.inc"		;token interpretation
SEOffset	equ	$8265
#ENDIF
#IFDEF TI83P
#include "doorscs.inc"		;token interpretation
SEOffset	equ	$86ec
#ENDIF
.list
	.org 0
	.db $BB,$6D
	.db $AB
#IFDEF TI83P
	.db $C9
#ENDIF
SEStart:
	.db $31
	.db $87
	.db $50
	.dw 0						;.dw SELoad-SEStart
	.dw SEMouse-SEStart
	.dw 0

SEMouse:
	ld a,(ix+1)
	or a
	jr nz,ycoord
	ld a,(ix)
	or a
	jr z,incpos
	bcall(_getcsc)
	cp $20
	jr z,incpos
	cp $28
	jr z,decpos
	ld d,0
	ret
ycoord:
	add a,2+4+96
	ld d,a
	xor a
	ld (ix+1),a
	ret
incpos:
	ld a,(ix)
	cp 20
	jr nz,inc2
	xor a
inc2:
	inc a
seta:
	ld (ix),a
	dec a
	add a,a
	ld e,a
	ld d,0
	ld hl,Vectortable-semouse+seoffset
	add hl,de
	inc hl
	ld a,(hl)
	ld (ix+1),a
	dec hl
	ld a,(hl)
	add a,6
	ld d,a
	ret
decpos:
	ld a,(ix)
	cp 1
	jr nz,dec2
	ld a,21
dec2:
	dec a
	jr seta
leftclick:
	ld d,1
	ret
rightclick:
	ld d,2
	ret
VectorTable:
	.db 13,11
	.db 42,11
	.db 70,11
	.db 13,39
	.db 42,39
	.db 70,39
	.db 92,3
	.db 92,52
	.db 8,59
	.db 21,59
	.db 92,59
	.db 86,9
	.db 86,12
	.db 86,18
	.db 86,24
	.db 86,30
	.db 86,36
	.db 86,42
	.db 86,48
	.db 86,54
.end
END